Subject: Re: FWD: Re: [PATCH net-next v1 1/1] net: dsa: microchip: ksz8: Make flow control, speed, and duplex on CPU port configurable

From: "Russell King (Oracle)" <[email-masked]>
Date: Tue, 11 Apr 2023 14:26:53 +0100

On Tue, Apr 11, 2023 at 04:12:15PM +0300, Vladimir Oltean wrote:
> On Tue, Apr 11, 2023 at 12:50:28PM +0100, Russell King (Oracle) wrote:
> > On Tue, Apr 11, 2023 at 02:16:09PM +0300, Vladimir Oltean wrote:
> > > On Tue, Apr 11, 2023 at 10:17:47AM +0100, Russell King (Oracle) wrote:
> > > > Since we can't manually control the tx and rx pause enables, I think
> > > > the only sensible way forward with this would be to either globally
> > > > disable pause on the device, and not report support for any pause
> > > > modes,
> > > 
> > > This implies restarting autoneg on all the other switch ports when one
> > > port's flow control mode is changed?
> > 
> > From my reading of these global register descriptions, no it doesn't,
> > and even if we did restart aneg, it would have no overall system effect
> > because the advertisements for each port haven't been changed. It's
> > mad hardware.
> > 
> > What I was meaning above is that we configure the entire switch to
> > either do autonegotiated flow control at setup time, or we configure
> > the switch to never do flow control.
> 
> I was thinking you were suggesting to also modify the advertisement in
> software from those other ports to 00 when the flow control was forced
> off on one. Otherwise (it seems you weren't), I think it's a bit
> counter-productive to configure the switch to never do flow control,
> when the only problem seems to be with the forced modes but autoneg is fine.

As I see it, there's essentially two possible options with this
hardware:

1. treat the switch as something that can negotiate pause modes.
2. treat the switch as something that doesn't support pause modes.

You are absolutely right that if (1) then its possible through the
advertisement to have (2) but the reverse is not true, so clearly
(1) is the better approach here.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!